stages:
  - prepare
  - build
  - release

variables:
  VERSION: "0.97.1"

Prepare sources:
  stage: prepare
  image: docker:20.10
  services:
    - docker:20.10-dind
  before_script:
    - apk add make curl
  script:
    - make sources
  cache:
    key:
      prefix: ${VERSION}
      files:
        - Makefile
    paths:
      - src
  artifacts:
    name: src
    paths:
      - src
  tags:
    - cg
    - docker

Build DEB:
  stage: build
  image: docker:20.10
  services:
    - docker:20.10-dind
  before_script:
    - apk add make
  script:
    - make deb
  artifacts:
    name: deb
    paths:
      - "deb/debbuild/**/*.deb"
  dependencies:
    - Prepare sources
  tags:
    - cg
    - docker

Build RPM:
  stage: build
  image: docker:20.10
  services:
    - docker:20.10-dind
  before_script:
    - apk add make
  script:
    - make rpm
  artifacts:
    name: rpm
    paths:
      - "rpm/rpmbuild/**/*.rpm"
  dependencies:
    - Prepare sources
  tags:
    - cg
    - docker

Upload:
  stage: release
  image: alpine:3.10
  before_script:
    - chmod 0400 "${SSH_KEY_FILE}"
    - mkdir ${HOME}/.ssh
    - chmod 0600 ${HOME}/.ssh
    - echo "${SSH_HOSTNAME} ${SSH_HOST_PUBLIC_KEY}" > ${HOME}/.ssh/known_hosts
    - apk add openssh-client
  script:
    - scripts/upload.sh "${SSH_HOSTNAME}" "${SSH_KEY_FILE}"
  rules:
    - if: '$CI_COMMIT_BRANCH != "master"'
      when: manual
      allow_failure: true
      variables:
        SSH_HOSTNAME: ""  # Provide manualy
        SSH_HOST_PUBLIC_KEY: "ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIN1cuHKvwKoIgEWFfFrf4ZbOwxBGamRXL+CJoHdpK9hf"
    - if: '$CI_COMMIT_BRANCH == "master"'
      variables:
        SSH_HOSTNAME: "52.143.27.189"
        SSH_HOST_PUBLIC_KEY: "ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAINhj35/ILgXi3Yewj4y7SsGy9Re4b6FJ/j1jR/evFCso"
  dependencies:
    - Build DEB
    - Build RPM
  tags:
    - cg
    - docker
